// CodeGear C++Builder
// Copyright (c) 1995, 2008 by CodeGear
// All rights reserved

// (DO NOT EDIT: machine generated header) 'Dx_dynamics.pas' rev: 20.00

#ifndef Dx_dynamicsHPP
#define Dx_dynamicsHPP

#pragma delphiheader begin
#pragma option push
#pragma option -w-      // All warnings off
#pragma option -Vx      // Zero-length empty class member functions
#pragma pack(push,8)
#include <System.hpp>	// Pascal unit
#include <Sysinit.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <Sysutils.hpp>	// Pascal unit
#include <Forms.hpp>	// Pascal unit
#include <Controls.hpp>	// Pascal unit
#include <Dialogs.hpp>	// Pascal unit
#include <Graphics.hpp>	// Pascal unit
#include <Extctrls.hpp>	// Pascal unit
#include <Menus.hpp>	// Pascal unit
#include <Dx_scene.hpp>	// Pascal unit
#include <Dx_utils.hpp>	// Pascal unit
#include <Dx_vgcore.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Dx_dynamics
{
//-- type declarations -------------------------------------------------------
class DELPHICLASS TdxParticle;
class DELPHICLASS TdxParticleList;
class DELPHICLASS TdxParticleEmitter;
class PASCALIMPLEMENTATION TdxParticle : public Classes::TPersistent
{
	typedef Classes::TPersistent inherited;
	
private:
	int FTag;
	Dx_scene::TdxVector FPosition;
	Dx_scene::TdxVector FVelocity;
	float FTangentVel;
	float FCentrifugalVel;
	float FCreationTime;
	float FCurrentTime;
	Dx_scene::TdxVector FRotationCenter;
	TdxParticleList* FOwner;
	TdxParticleEmitter* FEmitter;
	
public:
	__fastcall virtual TdxParticle(void);
	__fastcall virtual ~TdxParticle(void);
	__property TdxParticleEmitter* Emitter = {read=FEmitter, write=FEmitter};
	__property TdxParticleList* Owner = {read=FOwner, write=FOwner};
	__property Dx_scene::TdxVector Position = {read=FPosition, write=FPosition};
	__property Dx_scene::TdxVector Velocity = {read=FVelocity, write=FVelocity};
	__property int Tag = {read=FTag, write=FTag, nodefault};
};


typedef StaticArray<TdxParticle*, 1048576> TdxParticleArray;

typedef TdxParticleArray *PdxParticleArray;

class PASCALIMPLEMENTATION TdxParticleList : public Classes::TPersistent
{
	typedef Classes::TPersistent inherited;
	
public:
	TdxParticle* operator[](int index) { return Items[index]; }
	
private:
	TdxParticleEmitter* FOwner;
	Classes::TList* FItemList;
	TdxParticleArray *FDirectList;
	
protected:
	TdxParticle* __fastcall GetItems(int index);
	void __fastcall SetItems(int index, TdxParticle* Value);
	void __fastcall AfterItemCreated(System::TObject* Sender);
	
public:
	__fastcall virtual TdxParticleList(void);
	__fastcall virtual ~TdxParticleList(void);
	__property TdxParticleEmitter* Owner = {read=FOwner, write=FOwner};
	__property TdxParticle* Items[int index] = {read=GetItems, write=SetItems/*, default*/};
	int __fastcall ItemCount(void);
	int __fastcall AddItem(TdxParticle* AItem);
	void __fastcall RemoveAndFreeItem(TdxParticle* AItem);
	int __fastcall IndexOfItem(TdxParticle* AItem);
	void __fastcall Pack(void);
	__property PdxParticleArray List = {read=FDirectList};
};


#pragma pack(push,1)
struct TdxParticleReference
{
	
public:
	TdxParticle* particle;
	int distance;
};
#pragma pack(pop)


typedef TdxParticleReference *PParticleReference;

typedef StaticArray<TdxParticleReference, 1048576> TdxParticleReferenceArray;

typedef TdxParticleReferenceArray *PParticleReferenceArray;

#pragma pack(push,1)
struct TRegion
{
	
public:
	int count;
	int capacity;
	TdxParticleReferenceArray *particleRef;
	Classes::TPointerList *particleOrder;
};
#pragma pack(pop)


typedef TRegion *PRegion;

#pragma option push -b-
enum TdxBlendingMode { dxBlendAdditive, dxBlendBlend };
#pragma option pop

#pragma option push -b-
enum TdxParticleVelocityMode { svmAbsolute, svmRelative };
#pragma option pop

#pragma option push -b-
enum TdxParticleDispersionMode { sdmFast, sdmIsotropic };
#pragma option pop

typedef void __fastcall (__closure *TdxCreateParticleEvent)(System::TObject* Sender, TdxParticle* AParticle);

class DELPHICLASS TdxParticleKey;
class PASCALIMPLEMENTATION TdxParticleKey : public Classes::TCollectionItem
{
	typedef Classes::TCollectionItem inherited;
	
private:
	float FSpin;
	float FScale;
	unsigned FColor;
	unsigned FKey;
	System::AnsiString __fastcall GetColor();
	void __fastcall SetColor(const System::AnsiString Value);
	void __fastcall SetKey(const unsigned Value);
	
public:
	__fastcall virtual TdxParticleKey(Classes::TCollection* Collection);
	__fastcall virtual ~TdxParticleKey(void);
	float __fastcall time(void);
	
__published:
	__property unsigned Key = {read=FKey, write=SetKey, nodefault};
	__property System::AnsiString Color = {read=GetColor, write=SetColor};
	__property float Scale = {read=FScale, write=FScale};
	__property float Spin = {read=FSpin, write=FSpin};
};


class DELPHICLASS TdxParticleKeys;
class PASCALIMPLEMENTATION TdxParticleKeys : public Classes::TCollection
{
	typedef Classes::TCollection inherited;
	
public:
	TdxParticleKey* operator[](int Index) { return Keys[Index]; }
	
private:
	TdxParticleEmitter* FEmitter;
	TdxParticleKey* __fastcall GetKey(int Index);
	
public:
	__fastcall virtual TdxParticleKeys(void);
	__property TdxParticleKey* Keys[int Index] = {read=GetKey/*, default*/};
public:
	/* TCollection.Destroy */ inline __fastcall virtual ~TdxParticleKeys(void) { }
	
};


class PASCALIMPLEMENTATION TdxParticleEmitter : public Dx_scene::TdxDummy
{
	typedef Dx_scene::TdxDummy inherited;
	
private:
	typedef DynamicArray<Dx_scene::TdxColorTexVertexNormal> _TdxParticleEmitter__1;
	
	typedef DynamicArray<System::Word> _TdxParticleEmitter__2;
	
	
private:
	Dx_scene::TdxAnimation* FTimer;
	float FCurrentTime;
	TdxParticleKeys* FKeys;
	Dx_scene::TdxPosition* FGravity;
	Dx_scene::TdxPosition* FPositionDispersion;
	float FParticleInterval;
	TdxParticleVelocityMode FVelocityMode;
	TdxParticleDispersionMode FDispersionMode;
	bool FFollowToOwner;
	float FLifeTime;
	float FFriction;
	float FDirectionAngle;
	float FSpreadAngle;
	float FVelocityMin;
	float FCentrifugalVelMin;
	float FTangentVelMin;
	float FVelocityMax;
	float FCentrifugalVelMax;
	float FTangentVelMax;
	TdxParticleList* FParticles;
	TdxCreateParticleEvent FOnCreateParticle;
	Dx_scene::TdxVector FOldPosition;
	float FTimeRemainder;
	Dx_vgcore::TvxBounds* FRect;
	TdxBlendingMode FblendingMode;
	bool FZTest;
	System::AnsiString FBitmap;
	int FEditor;
	_TdxParticleEmitter__1 MeshVertices;
	_TdxParticleEmitter__2 MeshIndices;
	void __fastcall SetParticleInterval(const float Value);
	void __fastcall SetParticles(const TdxParticleList* Value);
	void __fastcall SetGravity(const Dx_scene::TdxPosition* Value);
	void __fastcall SetPositionDispersion(const Dx_scene::TdxPosition* Value);
	void __fastcall SetRect(const Dx_vgcore::TvxBounds* Value);
	void __fastcall SetBlendingMode(const TdxBlendingMode Value);
	void __fastcall SetZTest(const bool Value);
	void __fastcall SetCentrifugalVelMax(const float Value);
	void __fastcall SetCentrifugalVelMin(const float Value);
	void __fastcall SetTangentVelMax(const float Value);
	void __fastcall SetTangentVelMin(const float Value);
	void __fastcall SetVelocityMax(const float Value);
	void __fastcall SetVelocityMin(const float Value);
	void __fastcall SetBitmap(const System::AnsiString Value);
	System::AnsiString __fastcall GetColorMax();
	System::AnsiString __fastcall GetColorMin();
	float __fastcall GetScaleMax(void);
	float __fastcall GetScaleMin(void);
	float __fastcall GetSpinMax(void);
	float __fastcall GetSpinMin(void);
	void __fastcall SetColorMax(const System::AnsiString Value);
	void __fastcall SetColorMin(const System::AnsiString Value);
	void __fastcall SetScaleMax(const float Value);
	void __fastcall SetScaleMin(const float Value);
	void __fastcall SetSpinMax(const float Value);
	void __fastcall SetSpinMin(const float Value);
	float __fastcall GetParticleInterval(void);
	
protected:
	bool __fastcall FindKeys(const float ATime, TdxParticleKey* &Key1, TdxParticleKey* &Key2);
	void __fastcall ProcessEffect(float DeltaTime, float Time);
	void __fastcall SetLifeTime(const float Value);
	void __fastcall RenderParticle(const TdxParticle* APart, const int Idx, Dx_scene::TdxColorTexVertexNormal *Vertices, const int Vertices_Size, System::Word *Indices, const int Indices_Size);
	virtual void __fastcall Paint(void);
	
public:
	__fastcall virtual TdxParticleEmitter(Classes::TComponent* AOwner);
	__fastcall virtual ~TdxParticleEmitter(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	void __fastcall KillAll(void);
	void __fastcall Burst(float Time, int ParticlesCount);
	void __fastcall ComputeCurColor(float lifeTime, unsigned &curColor);
	bool __fastcall ComputeSizeScale(float lifeTime, float &sizeScale);
	bool __fastcall ComputeSpinAngle(float lifeTime, float &spinAngle);
	virtual TdxParticle* __fastcall CreateParticle(void);
	__property TdxParticleList* Particles = {read=FParticles, write=SetParticles};
	__property TdxParticleKeys* Keys = {read=FKeys, write=FKeys};
	
__published:
	__property int Editor = {read=FEditor, write=FEditor, stored=false, nodefault};
	__property System::AnsiString Bitmap = {read=FBitmap, write=SetBitmap};
	__property TdxBlendingMode BlendingMode = {read=FblendingMode, write=SetBlendingMode, default=0};
	__property Dx_scene::TdxPosition* Gravity = {read=FGravity, write=SetGravity};
	__property Dx_scene::TdxPosition* PositionDispersion = {read=FPositionDispersion, write=SetPositionDispersion};
	__property float ParticlePerSecond = {read=GetParticleInterval, write=SetParticleInterval};
	__property TdxParticleVelocityMode VelocityMode = {read=FVelocityMode, write=FVelocityMode, default=0};
	__property bool FollowToOwner = {read=FFollowToOwner, write=FFollowToOwner, nodefault};
	__property TdxParticleDispersionMode DispersionMode = {read=FDispersionMode, write=FDispersionMode, default=0};
	__property float DirectionAngle = {read=FDirectionAngle, write=FDirectionAngle};
	__property float SpreadAngle = {read=FSpreadAngle, write=FSpreadAngle};
	__property float Friction = {read=FFriction, write=FFriction};
	__property Dx_vgcore::TvxBounds* Rect = {read=FRect, write=SetRect};
	__property float LifeTime = {read=FLifeTime, write=SetLifeTime};
	__property float CentrifugalVelMin = {read=FCentrifugalVelMin, write=SetCentrifugalVelMin};
	__property float CentrifugalVelMax = {read=FCentrifugalVelMax, write=SetCentrifugalVelMax};
	__property float TangentVelMin = {read=FTangentVelMin, write=SetTangentVelMin};
	__property float TangentVelMax = {read=FTangentVelMax, write=SetTangentVelMax};
	__property float VelocityMin = {read=FVelocityMin, write=SetVelocityMin};
	__property float VelocityMax = {read=FVelocityMax, write=SetVelocityMax};
	__property System::AnsiString ColorBegin = {read=GetColorMin, write=SetColorMin};
	__property float ScaleBegin = {read=GetScaleMin, write=SetScaleMin};
	__property float SpinBegin = {read=GetSpinMin, write=SetSpinMin};
	__property System::AnsiString ColorEnd = {read=GetColorMax, write=SetColorMax};
	__property float ScaleEnd = {read=GetScaleMax, write=SetScaleMax};
	__property float SpinEnd = {read=GetSpinMax, write=SetSpinMax};
	__property TdxCreateParticleEvent OnCreateParticle = {read=FOnCreateParticle, write=FOnCreateParticle};
	__property TwoSide = {default=1};
	__property ZWrite = {default=0};
};


//-- var, const, procedure ---------------------------------------------------
static const Extended KeyTime = 3.333333E-02;

}	/* namespace Dx_dynamics */
using namespace Dx_dynamics;
#pragma pack(pop)
#pragma option pop

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// Dx_dynamicsHPP
